// queue.cpp
#include "queue.h"
using namespace std;

class Element {
	friend class Queue;
	Element *nasta;
	int data;
	Element(Element *n, int d) : nasta(n), data(d) {}
};

void Queue::push(int d) {
	Element *pny = new Element(0, d);
	if (empty())
		forsta = pny;
	else
		sista->nasta = pny;
	sista = pny;
}

// queue.cpp (forts.)
void Queue::pop() /*throw(length_error)*/ {
	if (empty())
		throw length_error("Queue::pop");
	Element *p = forsta;
	forsta = forsta->nasta;
	if (empty())
		sista = 0;
	delete p;
}

int Queue::front() /*throw(length_error)*/ {
	if (empty())
		throw length_error("Queue::front");
	return forsta->data;
}

// queue.cpp (forts.)
int Queue::back() /*throw(length_error)*/ {
	if (empty())
		throw length_error("Queue::back");
	return sista->data;
}
bool Queue::empty() {
	return !forsta;
}
// Destruktorn
Queue::~Queue() {
	while (!empty()) {
		Element *p = forsta;
		forsta = forsta->nasta;
		delete p;
	}
}
