// stack.cpp
#include "stack.h"
using namespace std;

class Element {
	friend class Stack;
	Element *nasta;
	int data;
	Element(Element *n, int d) :nasta(n), data(d) {}
};

void Stack::push(int d) {
	forsta = new Element(forsta, d);
}

void Stack::pop() /*throw(length_error)*/ {
	if (empty())
		throw length_error("Stack::pop");
	Element *p = forsta;
	int d = p->data;
	forsta = forsta->nasta;
	delete p;
}

int Stack::top() /*throw(length_error)*/ {
	if (empty())
		throw length_error("Stack::top");
	return forsta->data;
}

bool Stack::empty() {
	return !forsta;
}

Stack::~Stack() {
	while (!empty()) {// G igenom och ta bort
		Element *p = forsta;
		forsta = forsta->nasta;
		delete p;
	}
}
