#include <iostream>
using namespace std;

// <<<<<<<<<<<<<<<< slide 1 >>>>>>>>>>>>>>>>>>>>>>
class Element {
public:
	Element *fram, *bak;
	int data;
	Element(Element *f = nullptr, Element *b = nullptr, int d = 0)
		: fram(f), bak(b), data(d) { if (f == nullptr) fram = bak = this; }
};

// <<<<<<<<<<<<<<<< slide 2 >>>>>>>>>>>>>>>>>>>>>>
void ta_bort(Element *e) {
	e->bak->fram = e->fram;
	e->fram->bak = e->bak;
	delete e;
}

void lagg_fore(Element *e, int d) {
	Element *pny = new Element(e, e->bak, d);
	e->bak->fram = pny;
	e->bak = pny;
}

// <<<<<<<<<<<<<<<< slide 3 >>>>>>>>>>>>>>>>>>>>>>
// Lgga in frst i listan
void lagg_forst(Element *forsta, int d) {
	lagg_fore(forsta->fram, d);
}

// Lgga in efter
void lagg_efter(Element *e, int d) {
	lagg_fore(e->fram, d);
}

// Lgg in sist
void lagg_sist(Element *forsta, int d) {
	lagg_efter(forsta->bak, d);
}

// <<<<<<<<<<<<<<<< slide 4 >>>>>>>>>>>>>>>>>>>>>>
// framlnges
void skriv(Element *forsta) {
	Element *p;
	for (p = forsta->fram; p != forsta; p = p->fram)
		cout << p->data << ' ';
}

// ... och baklnges
void skriv_baklanges(Element *forsta) {
	Element *p;
	for (p = forsta->bak; p != forsta; p = p->bak)
		cout << p->data << ' ';
}

// <<<<<<<<<<<<<<<<  main   >>>>>>>>>>>>>>>>>>>>>>
int main() {
	Element *forsta = new Element;  // skapa tom lista
	lagg_forst(forsta, 4);
	lagg_forst(forsta, 5);
	lagg_forst(forsta, 2);
	skriv(forsta);   cout << endl;
	skriv_baklanges(forsta);   cout << endl;

	cin >> ws;

}
